------------------------------------------------------------------------------------------------------------------------------------------------
--"Layer State Manager v1.00"
--"produced by apras();"
--"http://www.apras.net/"
--
--
--memo
--C[̏(IuWFNgA\At[Y)XMLt@CƂďoƂł܂
--ǂݍݎAsIuWFNg "LSM_Unknown" Ɋi[܂
--ÕIuWFNgV[ɑ݂ꍇ́AԂ̕łȂꍇ܂
--
--
--How to use
-- "Import" Ńt@Cǂݍ݂܂
-- "Export" Ńt@Co܂
-- "Remove Objects" `FbNƓǂݍݎAsIuWFNg폜܂

--
--
--History
--2011/02/07	1.00	First release
--
--
--ɂ񂵂ČlIɎĝ́BĔzzƂ́~B
--zƂ̓[Rgł肢܂B
------------------------------------------------------------------------------------------------------------------------------------------------
try
(
	--gc light:true
	cui.UnRegisterDialogBar LsmTool 
	destroyDialog LsmTool 
)
catch
(
)

rollout LsmTool "Layer State Manager v1.00"
(
	
	------------------------------------------------------------------------
	--
	--
	-- \̒`
	------------------------------------------------------------------------	
	struct LayerState
	(
		LayerName,
		Visible,
		Frozen,
		NodeNames
	)	
	------------------------------------------------------------------------
	--
	--
	-- ϐ`
	------------------------------------------------------------------------
	local m_outPutFlag	= false
	local m_inPutFlag		= false
	local m_removeFlag	= false
	------------------------------------------------------------------------	
	--
	--
	-- C^[tF[X`
	------------------------------------------------------------------------	
	-- import
	groupBox  m_gp1 "Import" width:145 height:70 pos:[5, 10]
	checkbox  m_cb1 "Remove objects" pos:[10, 30] checked:true
	--spinner 	m_sp1 "rep:" range:[1,10,1] type:#integer pos:[105, 30] width:40
	button m_bt1 "Import"	width:135 height:20 pos:[10,50]
	-- export
	groupBox  m_gp2 "Export" width:145 height:50 pos:[5, 85]
	button m_bt2 "Export"	width:135 height:20 pos:[10,105]
	-- credit
	label m_lab1"produced by "pos:[10,142]
	hyperLink m_hl1 "www.apras.net" pos:[75, 142] address:"http://www.apras.net/" color:orange hoverColor:orange visitedColor:orange		
	------------------------------------------------------------------------
	--
	--
	-- [J֐
	------------------------------------------------------------------------
	--
	--\[g
	fn func_CompareLayerName v1 v2 =
	(
		case of
		(
			(v1.LayerName < v2.LayerName): -1
			(v1.LayerName > v2.LayerName): 1
			default: 0
		)
	)	
	
	fn func_CompareNodeName v1 v2 =
	(
		case of
		(
			(v1 < v2): -1
			(v1 > v2): 1
			default: 0
		)
	)		

	--
	-- 
	fn func_FindLayer Items ItemName = 
	(
		for _item in Items do
		(
			if ( _item.LayerName == ItemName ) then
				return _item
		)
		
		return undefined
	)
	
	fn func_FindNodes Items ItemName =
	(
		for _item in Items do
		(
			for _node in _item.NodeNames do
			(
				if ( _node == ItemName ) then
					return _item				
			)
		)
		
		return undefined
	)
	
	--
	-- ݃f[^W
	fn func_CollectExportData =
	(
		local _exportDataArray = undefined
		local _layerCount = layerManager.count
		
		if ( _layerCount > 0) then
		(
			_exportDataArray = #()
			m_outPutFlag = true

			for _i = 0 to layerManager.count-1 do
			(
				local _layer = layerManager.getLayer _i
				local _layerName = _layer.name 
				local _layerNodes = #()
				
				if ( _layer.nodes &_layerNodes ) then
				(
					local _layerState = func_FindLayer _exportDataArray _layerName
					
					if ( _layerState == undefined ) then
					(
						_layerState = LayerState ""
						_layerState.LayerName	= _layerName
						_layerState.Visible			= (not _layer.ishidden)
						_layerState.Frozen			= _layer.isfrozen
						_layerState.NodeNames	= #()
						append _exportDataArray _layerState
					)					
					
					for _node in _layerNodes do
						append _layerState.NodeNames _node.name

					qsort _layerState.NodeNames func_CompareNodeName
				)
				else
				(
					m_outPutFlag = false
					m_errorCode = 2
				)
			)
		)
		else
		(
			m_outPutFlag = false
			m_errorCode = 1
		)
		
		if ( m_outPutFlag ) then
			qsort _exportDataArray func_CompareLayerName	
		
		return _exportDataArray
	)	
	
	--
	-- ǂݍ݃f[^W
	fn func_CollectImportData =
	(
		local _importName = getOpenFileName caption:"select list File" types:"xml (*.xml)|*.xml|All Files (*.*)|*.*|"
		local _importDates = #()
		
		if (_importName != undefined) then
		(
			local _xmlDoc = dotNetObject "System.Xml.XmlDocument"
			_xmlDoc.load _importName
			--
			local _root = _xmlDoc.DocumentElement
						
			local _layers = _root.SelectNodes "/Layers/Layer"
			local _layersCount = _layers.Count - 1
			
			for _i = 0 to _layersCount do
			(
				local _layerState = LayerState ""
				--
				local _layer = (_layers.Item _i)
				
				_layerState.LayerName	= _layer.GetAttribute "Name"
				_layerState.Visible			= (_layer.GetAttribute "Visible") as booleanClass
				_layerState.Frozen			= (_layer.GetAttribute "Frozen") as booleanClass 
				_layerState.NodeNames	= #()
				
				local _nodes = _layer.SelectNodes "Node"
				local _nodesCount = _nodes.Count - 1
				
				for _n = 0 to _nodesCount do
				(
					local _node = _nodes.Item _n
					append _layerState.NodeNames _node.FirstChild.Value
				)
				append _importDates _layerState
			)
			m_inPutFlag = true
			return _importDates
		)
		else
		(
			m_errorCode = 4
			m_inPutFlag = false
			return _importDates
		)
	)		
	
	--
	-- GNX|[g
	fn func_Export pExportDates =
	(
		if (m_outPutFlag) then
		(
			local _outputName = getSaveFileName caption:"select list File" types:"xml (*.xml)|*.xml|All Files (*.*)|*.*|"
			if ( _outputName != undefined ) then
			(	
				local _xmlWriterSetting = dotNetObject "System.Xml.XmlWriterSettings" 
				_xmlWriterSetting.Encoding = (dotNetClass "System.Text.Encoding").UTF8
				_xmlWriterSetting.Indent = true
				_xmlWriterSetting.IndentChars = "\t"
				
				local _xmlWriterClass = dotNetClass "System.Xml.XmlWriter" 
				local _xmlWriter = _xmlWriterClass.Create _outputName _xmlWriterSetting
				
				_xmlWriter.WriteStartElement "Layers"
				
				for _data in pExportDates do
				(
					_xmlWriter.WriteStartElement "Layer"
					_xmlWriter.WriteAttributeString "Name" (_data.LayerName as string)
					_xmlWriter.WriteAttributeString "Visible" (_data.Visible as string)
					_xmlWriter.WriteAttributeString "Frozen" (_data.Frozen as string)
					
					for _node in _data.NodeNames do
					(
						_xmlWriter.WriteStartElement "Node"
						_xmlWriter.WriteValue _node
						_xmlWriter.WriteEndElement()
					)
					_xmlWriter.WriteEndElement()
				)
				_xmlWriter.WriteEndElement()
				_xmlWriter.Close()
				
				return true
			)
			else
			(
				m_errorCode = 3
				return false
			)
		)
		else
		(
			return false
		)
	)
	
	--
	-- C|[g
	fn func_Import pImportData = 
	(
		if (m_inPutFlag) then
		(
			local _objs = objects as array
			
			for _layerState in pImportData do
			(
				local _layer = LayerManager.getLayerFromName _layerState.LayerName
				
				if (_layer != undefined) then
				(
					_layer.ishidden	= (not _layerState.Visible)
					_layer.isfrozen	= _layerState.Frozen
				)
			)
			
			for _obj in _objs do
			(
				local _layerState = func_FindNodes pImportData _obj.name
				local _layerName = "LSM_Unknown"
				
				if (_layerState != undefined) then
				(
					_layerName = _layerState.LayerName
				)

				local _layer = LayerManager.getLayerFromName _layerName
				
				if (_layer == undefined) then
					_layer = LayerManager.newLayerFromName _layerName
				
				_layer.addnode _obj				
			)
			
			local _removeLayerName = #()
			for _i = 0 to layerManager.count-1 do
			(
				local _layerNodes = #()
				local _layer = layerManager.getLayer _i
				
				if ( _layer.nodes &_layerNodes ) then
				(	
					if ( _layerNodes.count == 0 ) then
						append _removeLayerName _layer.name
				)
			)
			
			for _layerName in _removeLayerName do
				LayerManager.deleteLayerByName _layerName
			
			if (m_removeFlag) then
			(
				local _layer = LayerManager.getLayerFromName "LSM_Unknown"
				
				if (_layer != undefined ) then
				(
					local _layerNodes = #()
					if (_layer.nodes &_layerNodes) then
					(
						delete _layerNodes
					)
					LayerManager.deleteLayerByName "LSM_Unknown"
				)
			)
			return true
		)
		else
		(
			return false
		)
	)
	
	--
	-- Abvf[g`FbN
	fn func_UpDateCheck =
	(
		if (internet.CheckConnection url:"http://www.apras.net/") then
		(
		
			local _url = "http://www.apras.net/contents/data_dev/script/index.xml"
			try
			(
				local _doc = dotNetObject "System.Xml.XmlDocument"
				_doc.load _url
				print _doc
				--
				local _xpath = "/softInfo/Lsm/latestVer"
				local _root = _doc.DocumentElement
				local _nodeList = _root.SelectNodes _xpath
				local _element = _nodeList.Item 0
				local _latastVer = _element.GetAttribute "ver"
				if ((_latastVer as float) > m_mineVersion) then
				(
					if (queryBox ("this is old version.\nupdate now ?") title:"update check !") then
					(
						ShellLaunch "http://www.apras.net/" ""
					)
				)
			)
			catch
			(
				messageBox ("disconnect network.") title:"error"
			)
		)
		
	)	
	
	------------------------------------------------------------------------
	--
	--
	-- Cxgnh`
	------------------------------------------------------------------------
	on LsmTool open do
	(
		dotnet.loadAssembly "system.xml.dll"
		--func_UpDateCheck()
		m_cb1.checked = m_removeFlag
	)
	
	on m_cb1 changed arg do
	(
		m_removeFlag = arg
	)
	
	on m_bt1 pressed do
	(
		undo "LSM File import" on
		(
			if (func_Import  (func_CollectImportData())) then
			(
				messageBox "Inport is completed."
			)
			else
			(
				case m_errorCode of
				(
					4: ( messageBox "Failed to file input." title:"error" )
				)				
			)
		)
		m_inputFlag = false
		m_errorCode = -1
	)
	
	on m_bt2 pressed do
	(
		if (func_Export (func_CollectExportData())) then
		(
			messageBox "Export is completed."
		)
		else
		(
			case m_errorCode of
			(
				1: ( messageBox "Layer does not exist." title:"error" )
				2: ( messageBox "Failed to get nodes." title:"error" )
				2: ( messageBox "Failed to file output." title:"error" )
			)
		)
		m_outPutFlag = false
		m_errorCode = -1
	)

)
createDialog LsmTool 160 155
cui.RegisterDialogBar LsmTool style:#(#cui_floatable, #cui_handles) 